<?php

namespace FiloBlu\ExtAmastyGeoipRedirect\Plugin\App\Config;

use FiloBlu\ExtAmastyGeoipRedirect\Cookie\Country;
use Magento\Directory\Helper\Data;
use Magento\Framework\Stdlib\CookieManagerInterface;
use Magento\Store\Model\ScopeInterface;
use Magento\Tax\Model\Config;

/**
 * Class ScopeConfigInterface
 * @package FiloBlu\ExtAmastyGeoipRedirect\Plugin\App\Config
 */
class ScopeConfigInterface
{
    /**
     * @var string
     */
    const CONFIG_AFFECTED_COUNTRY = 'amgeoipredirect/country_store/affected_countries';

    /**
     * @var CookieManagerInterface
     */
    protected $cookieManager;

    /**
     * ScopeConfigInterface constructor.
     * @param CookieManagerInterface $cookieManager
     */
    public function __construct(CookieManagerInterface $cookieManager)
    {
        $this->cookieManager = $cookieManager;
    }

    /**
     * @param \Magento\Framework\App\Config\ScopeConfigInterface $subject
     * @param $result
     * @param $path
     * @param string $scopeType
     * @param string $scopeCode
     * @return string|null
     */
    public function afterGetValue(
        \Magento\Framework\App\Config\ScopeConfigInterface $subject,
        $result,
        $path,
        $scopeType = \Magento\Framework\App\Config\ScopeConfigInterface::SCOPE_TYPE_DEFAULT,
        $scopeCode = null
    ) {
        switch ($path) {
            case Config::CONFIG_XML_PATH_DEFAULT_COUNTRY:
            case Data::XML_PATH_DEFAULT_COUNTRY:

                if (($cookieValue = $this->cookieManager->getCookie(Country::COOKIE_NAME, null)) !== null) {
                    $countries = $subject->getValue(self::CONFIG_AFFECTED_COUNTRY, ScopeInterface::SCOPE_STORES);

                    foreach (explode(',', $countries) as $country) {
                        if ($country === $cookieValue) {
                            return $country;
                        }
                    }
                }
        }

        return $result;
    }
}
